/*
 * XBee End Device
 * ----------------
 * XBee star topology (1 sender > N receivers)
 * XBee #1 is the coordinator (one sender)
 * XBee #2, #3, ... are end devices (multiple receivers)
 * Coordinator : ATRE, ATID1111, ATBD6, ATCE1, ATAP2, ATWR
 * End #2      : ATRE, ATID1111, ATBD6, ATMY2, ATAP2, ATWR
 * End #3      : ATRE, ATID1111, ATBD6, ATMY3, ATAP2, ATWR
 * ...
 */

#include <XBee.h>

XBee xbee = XBee();
XBeeResponse response = XBeeResponse();
Rx16Response rx16 = Rx16Response();

int dataLed = 9;

int data0 = 0;
int lastdata0 = 0;
int data1 = 0;
int lastdata1 = 0;
int data2 = 0;
int lastdata2 = 0;
int data3 = 0;
int lastdata3 = 0;
int data4 = 0;
int lastdata4 = 0;
int data5 = 0;
int lastdata5 = 0;

void setup() {
  pinMode(dataLed, OUTPUT);   
  Serial.begin(57600);
  xbee.setSerial(Serial);
}

void loop() {  
    xbee.readPacket();
    if (xbee.getResponse().isAvailable()) {
        if (xbee.getResponse().getApiId() == RX_16_RESPONSE) {
          
           // get packet
           xbee.getResponse().getRx16Response(rx16);
          
           // get data
           data0 = rx16.getData(0);
           data1 = rx16.getData(1);
           data2 = rx16.getData(2);
           data3 = rx16.getData(3);
           data4 = rx16.getData(4);
           data5 = rx16.getData(5);
           
           // update values only if it changes
           if (data0 != lastdata0 && data0 >= 0) {
             Serial.print("data0 : ");
             Serial.print(data0);
             Serial.print(" ");
             analogWrite(dataLed, data0);
           }
           if (data1 != lastdata1 && data1 >= 0) {
             Serial.print("data1 : ");
             Serial.print(data1);
             Serial.print(" ");
           }
           if (data2 != lastdata2 && data2 >= 0) {
             Serial.print("data2 : ");
             Serial.print(data2);
             Serial.print(" ");
           }
           if (data3 != lastdata3 && data3 >= 0) {
             Serial.print("data3 : ");
             Serial.print(data3);
             Serial.print(" ");
           }
           if (data4 != lastdata4 && data4 >= 0) {
             Serial.print("data4 : ");
             Serial.print(data4);
             Serial.print(" ");
           }
           if (data5 != lastdata5 && data5 >= 0) {
             Serial.print("data5 : ");
             Serial.print(data5);
             Serial.print(" ");
           }
           Serial.println();
           
           // update last values
           lastdata0 = data0;
           lastdata1 = data1;
           lastdata2 = data2;
           lastdata3 = data3;
           lastdata4 = data4;
           lastdata5 = data5;
         }
    }
}
